# GUI de CAPA en TCL TK



proc scitune_setHeight {w height} {
    
	global scitune_affichage_en_cours
	global scitune_liste_parameter
	global scitune_liste_value

	if {$scitune_affichage_en_cours==0} {

	set scitune_liste_value {}
	


		foreach i $scitune_liste_parameter {
			
			global scitune_user_[set i]_value


			lappend scitune_liste_value [set scitune_user_[set i]_value]
			

		}


		 set scitune_affichage_en_cours 1
		 ScilabEval "SCITUNE_DISPLAY_MAJ();"
		
	}
 
}



 proc scitune_validate_key {value} {
	
    if {
		[string is double $value]
	} then {
return 1
    }
    return 0
 }

# Proprits de la fenetre
	set w .scitune
	catch {destroy $w}
	toplevel $w
	wm title $w "Scilab Tuning"
	wm resizable $w 0 0
	wm protocol $w WM_DELETE_WINDOW "ScilabEval \"scitune_sortie=%T;\";"
	
	frame $w.tuning 	

	pack $w.tuning -side top -anchor w 





# =============================================
# Initialisation des variables
# =============================================	

	set scitune_affichage_en_cours 0

	# set scitune_liste_name [list 		"C0 (fF)" 	"C1 (fF)" 	"a" 	"Vm (V)" 	"C2 (fF)" 	"b" 	"Vp (V)" ]

	# set scitune_liste_parameter [list 	C0 			C1 		a 			Vm 			C2 			b 		Vp ]
 	# set scitune_liste_value [list 	59.37 		59.57 	6.77 		6.79 		12.58 		25.31 	5.56]
	# set scitune_liste_min [list 		10			5		0.1			0.5			2			10		1]
	# set scitune_liste_max [list 		90 			95		20			25			50			50		14]


		foreach i $scitune_liste_parameter {
			
			global scitune_user_[set i]_value
			global scitune_user_[set i]_max
			global scitune_user_[set i]_min

			set scitune_user_[set i]_value [lindex $scitune_liste_value [lsearch $scitune_liste_parameter $i]]
			set scitune_user_[set i]_max [lindex $scitune_liste_max [lsearch $scitune_liste_parameter $i]]
			set scitune_user_[set i]_min [lindex $scitune_liste_min [lsearch $scitune_liste_parameter $i]]




		}


# ==============================================
# ==============================================
#	Affichage des optim
# ==============================================
# ==============================================
#	set w .scicapa.command.optim
#	button $w.b -text "Optimize" -width 7 -command {ScilabEval "CAPA_TK_optim(Vgs,Cgs,Vgd,Cgd);"}
#	pack $w.b -side left 

#	set w .scicapa.command.switch
#	button $w.b1 -text "Cgs" -width 7 -command {ScilabEval "CAPA_TK_switch('cgs');"}
#	button $w.b2 -text "Cgd" -width 7 -command {ScilabEval "CAPA_TK_switch('cgd');"}
	
#	pack $w.b1 $w.b2 -side left 




# ==============================================
# ==============================================
#	Affichage des tuness
# ==============================================
# ==============================================

	set w .scitune.tuning
	
	
		foreach i $scitune_liste_parameter { 
			label $w.label_[set i] -text [lindex $scitune_liste_name [lsearch $scitune_liste_parameter $i]]
			scale $w.scale_[set i] -orient vertical -width 10 -length 200 -from [set scitune_user_[set i]_max] -to [set scitune_user_[set i]_min]  -digits 4 -resolution 0.001 -variable scitune_user_[set i]_value -command "scitune_setHeight 1"
			entry $w.entry_[set i]_max -textvariable scitune_user_[set i]_max -width 7 
			entry $w.entry_[set i]_min -textvariable scitune_user_[set i]_min -width 7
			eval "bind \$w.entry_[set i]_max <Key> \{ if \{\[string equal %K Return\]\} then \{ $w.scale_[set i] configure -from \$scitune_user_[set i]_max \}\}"
			eval "bind \$w.entry_[set i]_min <Key> \{ if \{\[string equal %K Return\]\} then \{ $w.scale_[set i] configure -to \$scitune_user_[set i]_min \}\}"
			# eval "bind \$w.scale_[set i] <ButtonRelease>  \{setHeight [set j]_[set i] \$[set j]_[set i]_value\}" 

			grid $w.label_$i -row 2 -column [expr [lsearch $scitune_liste_parameter $i]+1]
			grid $w.entry_[set i]_max -row 3 -column [expr [lsearch $scitune_liste_parameter $i]+1]
			grid $w.scale_$i -row 4 -column [expr [lsearch $scitune_liste_parameter $i]+1]
			grid $w.entry_[set i]_min -row 5 -column [expr [lsearch $scitune_liste_parameter $i]+1]
		
		
		}
	
